body {
    height: 100vh;
    background: #111;
    display: flex;
    justify-content: center;
    align-items: center;
}

a {
    text-decoration: none;
    color: #262626;
    font-family: roboto;
    font-size: 40px;
    border: 5px solid #5500FF;
    border-radius: 15px;
    font-weight: 300;
    letter-spacing: 0;
    padding: 50px 120px;
    position: relative;
    overflow: hidden;
    transition: background 0.8s;
}

a span,
a .icon {
    width: 100%;
    height: 100%;
    position: absolute;
    top: 0;
    transition: all .3s;
    display: flex;
    justify-content: center;
    align-items: center;
}

a span{
    left: 0;
}

a .icon{
    left: 100%;
}

a:hover span{
    left: -100%;
}

a:hover .icon{
    left: 0;
}